const shell = require("shelljs");
const chalk = require("chalk");
const systemMap = require("../system");
const util = require("./node-file-util");

let system = process.argv.splice(2);
!system.length && (system = Object.keys(systemMap));

async function build(key) {
  return new Promise((resolve, reject) => {
    const command = `cd ../${key} && npm run build`;
    console.log(chalk.yellow(`开始构建子系统${key}，执行：${command}`));
    shell.exec(
      command,
      {
        maxBuffer: 1024 * 1024 * 1024,
      },
      (error, stdout, stderr) => {
        if (error) {
          console.error(`子系统${key}构建失败，执行的错误: ${error}`);
          resolve();
        }
        console.log(chalk.green(`子系统${key}构建成功`));
        resolve();
      }
    );
  });
}

async function execute() {
  !util.isExists("./dist") && util.createFolder("./dist");
  for (let key of system) {
    try {
      const src = `../${key}/dist`;
      const tar = `./dist/${key}`;
      util.delete(tar);
      await build(key);
      if (util.isExists(src)) {
        util.copy(src, tar);
      }
    } catch (error) {
      console.log(error);
    }
  }
}

execute();
